﻿var resourceJSON = "";

function getUrl() {
    "use strict";
    

    var docUrl = document.location.href;

    
    var beginIndex = docUrl.indexOf('#') + 1;

    var urlResult;
    
    if (docUrl.indexOf("file://", beginIndex) == -1) {
        
        var protocolEndIndex = docUrl.indexOf("://", beginIndex);

        
        var endIndex = docUrl.indexOf("/", protocolEndIndex + 3);
        urlResult = docUrl.substring(beginIndex, endIndex);
    }
    else {
        urlResult = docUrl.substring(beginIndex);
    }

    return urlResult
}

function isExternalUrlSafeForNavigation(urlStr) {
    "use strict";
    var regEx = new RegExp("^(http(s?)|ftp|file)://", "i");
    return regEx.exec(urlStr);
}

function clickRefresh() {
    "use strict";
    var currentLocation = document.location.href;
    var poundIndex = currentLocation.indexOf('#');

    if (poundIndex != -1 && poundIndex + 1 < currentLocation.length && isExternalUrlSafeForNavigation(currentLocation.substring(poundIndex + 1))) {
        window.location.replace(currentLocation.substring(poundIndex + 1));
    }
}

function clickSearch() {
    "use strict";
    var currentLocation = document.location.href;
    var poundIndex = currentLocation.indexOf('#');

    if (poundIndex != -1 && poundIndex + 1 < currentLocation.length && isExternalUrlSafeForNavigation(currentLocation.substring(poundIndex + 1))) {
        window.open('https://www.bing.com/search?q=' + currentLocation.substring(poundIndex + 1) + '&PC=MENEPB');
    }
}

function getNavigationURL() {
    "use strict";
    var currentLocation = document.location.href;
    var poundIndex = currentLocation.indexOf('#');
    var possibleNavigationURL = currentLocation.substring(poundIndex + 1);

    if (poundIndex != -1 && poundIndex + 1 < currentLocation.length && isExternalUrlSafeForNavigation(possibleNavigationURL)) {
        return possibleNavigationURL;
    } else {
        return '';
    }
}

function isMergedErrorFile() {
    "use strict";
    var url = document.location.href.toLowerCase();
    
    var localAnchor = url.indexOf("#");
    url = url.substring(0, (localAnchor == -1) ? url.length : localAnchor);

    var query = url.indexOf("?");
    url = url.substring(0, (query == -1) ? url.length : query);

    return url.indexOf("errorpages.html", url.lastIndexOf("/") + 1) >= 0;
}

function getErrorCodeFromQuery() {
    "use strict";
    var errorCode = '';
    var errorQueryKey = "error=";

    var query = document.location.search;
    var errorQueryStart = query.indexOf(errorQueryKey);
    if (errorQueryStart > 0) {
        var ampersandStart = query.indexOf("&", errorQueryStart);
        if (ampersandStart > 0) {
            errorCode = query.substring(errorQueryStart + errorQueryKey.length, ampersandStart);
        } else {
            errorCode = query.substring(errorQueryStart + errorQueryKey.length);
        }
    }

    return errorCode;
}

function showErrorPage() {
    "use strict";
    if (isMergedErrorFile()) {
        setWebpageUrl();

        var errorCode = getErrorCodeFromQuery();
        setDocumentTitle(errorCode);
        initializeErrorCodeDiv(errorCode);
        initializeContinueLink(errorCode);

        
        document.getElementById(errorCode).style.display = "inline";
    }
}

function goToLocalizedErrorPage() {
    "use strict";
     showErrorPage();
}

function setWebpageUrl() {
    "use strict";
    var url = getUrl();
    var urlElements = document.getElementsByClassName("webpageURL");
    for (var i = 0; i < urlElements.length; i++) {
        urlElements[i].textContent = url;
    }
}

function setDocumentTitle(errorCode) {
    "use strict";
    
    if (errorCode == 3) { document.title = L_Syntax_Title_TEXT; }
    else if (errorCode == 4) { document.title = L_NavCancel_Title_TEXT; }
    else if (errorCode == 5) { document.title = L_PhishingSite_Title_TEXT; }
    else if (errorCode == 6) { document.title = L_InvalidCert_Title_TEXT; }
    else if (errorCode == 7) { document.title = L_SSLNavCancel_Title_TEXT; }
    else if (errorCode == 8) { document.title = L_UnknownProtocol_Title_TEXT; }
    else if (errorCode == 9) { document.title = L_ForbidFraming_Title_TEXT; }
    else if (errorCode == 10) { document.title = L_ProxyError_Title_TEXT; }
    
    else if (errorCode == 12) { document.title = L_TLSError_Title_TEXT; }
    
    else if (errorCode == 14) { document.title = L_HSTS_Title_TEXT; }
    
    else if (errorCode == 17) { document.title = L_PDF_Title_TEXT; }
    else if (errorCode == 18) { document.title = L_PDF_Title_TEXT; }
    else if (errorCode == 400) { document.title = L_Http_400_Title_TEXT; }
    else if (errorCode == 403) { document.title = L_Http_403_Title_TEXT; }
    else if (errorCode == 404) { document.title = L_Http_404_Title_TEXT; }
    else if (errorCode == 405) { document.title = L_Http_405_Title_TEXT; }
    else if (errorCode == 406) { document.title = L_Http_406_Title_TEXT; }
    else if (errorCode == 408) { document.title = L_Http_408_409_Title_TEXT; }
    else if (errorCode == 409) { document.title = L_Http_408_409_Title_TEXT; }
    else if (errorCode == 410) { document.title = L_Http_410_Title_TEXT; }
    else if (errorCode == 500) { document.title = L_Http_500_Title_TEXT; }
    else if (errorCode == 501) { document.title = L_Http_501_Title_TEXT; }
    else if (errorCode == 505) { document.title = L_Http_501_Title_TEXT; }
    else if (errorCode == 100004) { document.title = L_WPC_Title_TEXT; }
    else if (errorCode == 100005) { document.title = L_Disable_About_Flag_Title_TEXT; }
    else if (errorCode == 100006) { document.title = L_StartFresh_Title_TEXT; }
}

function initializeErrorCodeDiv(errorCode) {
    "use strict";
    if (errorCode == 1 || errorCode == 2) {
        
        initializeDnsError();
    }
    else if (errorCode == 100004) {
        handleWpcBlockedFrame();
    }
}

function initializeContinueLink(errorCode) {
    "use strict";
    if (errorCode == 6) {
        document.getElementById('continueLink').href = getNavigationURL();
    }
}

function initializeDnsError() {
    "use strict";
    
    checkConnectionForDnsError();

    
    if (document.addEventListener) {
        addEventListener("offline", reportConnectionEvent, false);
    }
    else {
        attachEvent("onoffline", reportConnectionEvent);
    }

    
    document.body.ononline = reportConnectionEvent;
    document.body.onoffline = reportConnectionEvent;
}

function checkConnectionForDnsError() {
    "use strict";
    var notConnected = document.getElementById("NotConnected");
    var pageUnavailable = document.getElementById("PageUnavailable");

    if (navigator.onLine) { 
        document.title = L_Unavailable_Title_TEXT;

        notConnected.style.display = "none";
        pageUnavailable.style.display = "";
    }
    else { 
        document.title = L_Disconnected_Title_TEXT;

        notConnected.style.display = "";
        pageUnavailable.style.display = "none";
    }
}

function isInApplicationGuard() {
    "use strict";
    var regExp = new RegExp("[?&;]InApplicationGuard=([^&#;]*)");
    var value = (regExp.exec(document.location.search) || [null, ""])[1];

    return (decodeURIComponent(value) || "0") === "1";
}

function reportConnectionEvent(e) {
    "use strict";
    if (!e) e = window.event;

    if ('online' == e.type) {
        
        setTimeout("clickRefresh()", 1000);
    }
    else {
        checkConnectionForDnsError();
    }
}


function getWpcBlockPageURL() {
    "use strict";

    var params = document.location.search;
    var server = "origin.sdx.microsoft.com";

    var errorParam = "error=100004&"
    var queryIdx = params.indexOf(errorParam);
    if (queryIdx != -1) {
        params = params.substring(queryIdx + errorParam.length);
    }

    var isIntEnv = "env=int&";
    var intIdx = params.indexOf(isIntEnv);
    if (intIdx != -1) {
        server = "sdx.microsoft-int.com";
        params = params.substring(intIdx + isIntEnv.length);
    }
    return 'https://' + server + '/family/restricted-web2?' + params;
}


function handleWpcBlockedFrame() {
    "use strict";
    var link = document.getElementById('wpcReqAcc');
    if (link) {
        link.href = getWpcBlockPageURL();
    }
}

function findValue(key) {
    "use strict";
    var value = '';

    var DocQuery = document.location.href;
    var BeginString = DocQuery.indexOf(key);

    if (BeginString > 0) {
        BeginString += key.length;
        var ampLocation = DocQuery.indexOf("&", BeginString);
        var poundLocation = DocQuery.indexOf("#", BeginString);

        var EndString = 0;
        if (ampLocation > 0 && poundLocation > 0) {
            EndString = Math.min(ampLocation, poundLocation);
        }
        else if (ampLocation > 0) {
            EndString = ampLocation;
        }
        else if (poundLocation > 0) {
            EndString = poundLocation;
        }

        if (EndString > 0) {
            value = DocQuery.substring(BeginString, EndString);
        }
        else {
            value = DocQuery.substring(BeginString);
        }
    }

    return value;
}

function getDisplayValue(elem) {
    "use strict";
    var objStyle;
    if (window.getComputedStyle) {
        objStyle = window.getComputedStyle(elem);
    } else {
        objStyle = elem.currentStyle;
    }
    return objStyle.display;
}

function initMoreInfo(infoBlockID, moreInfoText) {
    "use strict";
    document.getElementById("moreInformationDropdownLink").setAttribute("aria-label", moreInfoText);
    document.getElementById("moreInformationDropdownSpan").innerText = moreInfoText;

    expandCollapseDetails(infoBlockID);
}

function expandCollapseDetails(elem) {
    "use strict";
    if (document.getElementById) {
        var ecBlock = document.getElementById(elem);

        if (ecBlock != null) {
            var displayValue = getDisplayValue(ecBlock);
            if (displayValue == "none" || displayValue == null || displayValue == "") {
                
                ecBlock.style.display = "block";
            }
            else if (displayValue == "block") {
                
                ecBlock.style.display = "none";
            }
            else {
                
                ecBlock.style.display = "block";
            }
        }
    }
}

function getCertErrorInfo() {
    "use strict";

    var iError = certError();
    var iPolicy = preventIgnoreCertErrors();
    var sRealPageUrl = getNavigationURL();

    

    
    var iCertUnknownCA = 16777216;

    
    var iCertExpired = 67108864;

    
    var iCertCNMismatch = 33554432;

    
    var iCertRevoked = 12170;

    
    var iCertWeakSignature = 2097152;

    var certReasons = [];
    var errorCodes = [];

    
    if (iError == iCertRevoked) {
        certReasons.push(L_CertRevoked_TEXT);
        errorCodes.push("ERROR_INTERNET_SEC_CERT_REVOKED");
        if (document.getElementById("override")) {
            document.getElementById("override").style.display = "none";
        }
    }
    else {
        if (iError & iCertUnknownCA) {
            certReasons.push(L_CertUnknownCA_TEXT);
            errorCodes.push("DLG_FLAGS_INVALID_CA");
        }

        if (iError & iCertExpired) {
            certReasons.push(L_CertExpired_TEXT);
            errorCodes.push("DLG_FLAGS_SEC_CERT_DATE_INVALID");
        }

        if (iError & iCertCNMismatch) {
            certReasons.push(L_CertCNMismatch_TEXT);
            errorCodes.push("DLG_FLAGS_SEC_CERT_CN_INVALID");
        }

        if (iError == 0) {
            certReasons.push(L_CertSigFailed_TEXT);
            errorCodes.push("0");
        }

        if (iError & iCertWeakSignature) {
            certReasons.push(L_CertWeakSignature_TEXT);
            errorCodes.push("DLG_FLAGS_WEAK_SIGNATURE");
        }

        if (document.getElementById("override")) {
            if (iPolicy == 1 || iError == 0) {
                document.getElementById("override").style.display = "none";
            }
            else {
                document.getElementById("overridelink").href = sRealPageUrl;
            }
        }
    }

    if (certReasons.length > 0) {
        document.getElementById("certReason").innerHTML = certReasons.join("<br>");
    }

    if (errorCodes.length > 0) {
        document.getElementById("ErrorCode").innerHTML = L_ERROR_CODE_TEXT + errorCodes.join("<br>");
    }
}

function certError() {
    "use strict";

    var error = '0';

    var DocQuery = document.location.search;
    var BeginError = DocQuery.indexOf("SSLError=");

    if (BeginError > 0) {
        BeginError += 9;
        var EndError = DocQuery.indexOf("&", BeginError);

        if (EndError > 0) {
            error = DocQuery.substring(BeginError, EndError);
        }
        else {
            error = DocQuery.substring(BeginError);
        }
    }

    return error;
}

function preventIgnoreCertErrors() {
    "use strict";

    var Policy = '0';

    var DocQuery = document.location.search;
    var BeginPolicy = DocQuery.indexOf("PreventIgnoreCertErrors=") + 24;
    if (BeginPolicy > 0) {
        var EndPolicy = DocQuery.indexOf("&", BeginPolicy);
        if (EndPolicy > 0) {
            Policy = DocQuery.substring(BeginPolicy, EndPolicy);
        }
        else {
            Policy = DocQuery.substring(BeginPolicy);
        }
    }

    return Policy;
}